package es.uva.tfg.geolocalizationgame.controllers;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

/**
 * Controlador de arranque de la aplicacion. 
 * Incluye el enrutamiento de la pagina principal.
 * 
 * @author Cristina Gómez Escribano
 * @version 1.1
 * @since 27/08/2018
 *
 */
@Controller
public class RunController {

	/**
	 * Pagina principal de la aplicacion
	 */
	private static final String PAGINA_PRINCIPAL = "index";

	/**
	 * Recibe la peticion para mostrar la pagina principal de la aplicacion
	 * 
	 * @return ModelAndView vista principal
	 */
	@RequestMapping(value = { "/", "/portada", "/register", "/login", "/home", "/help", "/home/**" })
	public ModelAndView paginaPrincipal() {
		ModelAndView vista = new ModelAndView(PAGINA_PRINCIPAL);
		return vista;
	}
}
