package es.uva.tfg.geolocalizationgame.persistence;

import java.io.Serializable;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import es.uva.tfg.geolocalizationgame.resources.NivelDificultad;


/**
 * Implementa la clase de persistencia para la entidad NivelDificultad.
 * 
 * @author Cristina Gomez Escribano
 * @since 29/11/2018
 * @version 1.0
 *
 */
public interface NivelDificultadRepository extends JpaRepository<NivelDificultad, Serializable> {

	
	/**
	 * Obtiene el nivel de dificultad que contiene la palabra que se esta pasando como parametro.
	 * 
	 * @param nivel
	 * @return NivelDificultad
	 */
	@Query("select nivelDificultad from NivelDificultad nivelDificultad where (UPPER(nivelDificultad.nivelDificultad) LIKE CONCAT('%',:nivel,'%'))")
	NivelDificultad obtenerNivelDificultadByNombre(@Param(value = "nivel") String nivel);
}
