package es.uva.tfg.geolocalizationgame.persistence;

import java.io.Serializable;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import es.uva.tfg.geolocalizationgame.resources.TipoPunto;

/**
 *  Implementa la clase de persistencia para la entidad TipoPunto.
 *  
 * @author Cristina Gomez Escribano
 * @since 20/12/2018
 * @version 1.0
 *
 */
public interface TipoPuntoRepository extends JpaRepository<TipoPunto, Serializable> {

	/**
	 * Obtiene el tipo de punto por nombre.
	 * 
	 * @param nombreTipo
	 * @return TipoPunto
	 */
	@Query("select tipo from TipoPunto tipo where tipo.tipoPunto=:nombreTipo")
	TipoPunto obtenerTipoPuntoByNombre(@Param(value = "nombreTipo") String nombreTipo);

}
