package es.uva.tfg.geolocalizationgame.persistence;

import java.io.Serializable;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import es.uva.tfg.geolocalizationgame.resources.TipoVisibilidad;

/**
 * Operaciones con las consultas de acceso a datos para la entidad TipoVisibilidad
 * 
 * @author Cristina Gómez Escribano
 * @since 16/09/2018
 * @version 2.0
 *
 */
public interface TipoVisibilidadRepository extends JpaRepository<TipoVisibilidad, Serializable> {

	/**
	 * Obtiene el tipo de visibilidad por nombre.
	 * 
	 * @param nombre
	 * @return TipoVisibilidad
	 */
	@Query("select tipo from TipoVisibilidad tipo where tipo.tipoVisibilidad=:nombre")
	TipoVisibilidad obtenerVisibilidadByNombre(@Param(value = "nombre")String nombre);

}
