package es.uva.tfg.geolocalizationgame.resources;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

/**
 * Definicion de la entidad NivelDificultad.
 * 
 * @author Cristina Gomez Escribano
 * @version 2.0
 * @since 12/10/2018
 *
 */
@Entity
@Table(name = "nivel_dificultad")
public class NivelDificultad implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@Column(name="ID_NIVEL_DIFICULTAD", unique = true)
	private Integer idNivelDificultad;
	
	@Column(name="NIVEL_DIFICULTAD")
	@NotNull
	private String nivelDificultad;

	public NivelDificultad() {
		super();
	}

	public NivelDificultad(Integer idNivelDificultad, String nivelDificultad) {
		super();
		this.idNivelDificultad = idNivelDificultad;
		this.nivelDificultad = nivelDificultad;
	}

	public Integer getIdNivelDificultad() {
		return idNivelDificultad;
	}

	public void setIdNivelDificultad(Integer idNivelDificultad) {
		this.idNivelDificultad = idNivelDificultad;
	}

	public String getNivelDificultad() {
		return nivelDificultad;
	}

	public void setNivelDificultad(String nivelDificultad) {
		this.nivelDificultad = nivelDificultad;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((idNivelDificultad == null) ? 0 : idNivelDificultad.hashCode());
		result = prime * result + ((nivelDificultad == null) ? 0 : nivelDificultad.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		NivelDificultad other = (NivelDificultad) obj;
		if (idNivelDificultad == null) {
			if (other.idNivelDificultad != null)
				return false;
		} else if (!idNivelDificultad.equals(other.idNivelDificultad))
			return false;
		if (nivelDificultad == null) {
			if (other.nivelDificultad != null)
				return false;
		} else if (!nivelDificultad.equals(other.nivelDificultad))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "NivelDificultad [idNivelDificultad=" + idNivelDificultad + ", nivelDificultad=" + nivelDificultad + "]";
	}
}
