app.controller('JuegoController', function($scope, $rootScope, $compile, $location, JuegoService, ComentarioService, PuntoGeograficoService, MapaService) {
	$rootScope.portada=false;
	scrollToTopNoAnimated();
	var idJuego=undefined;
	$scope.creador=false;
	$scope.edicionNombre=false;
	$scope.edicionComentario=false;
	$scope.nameOld=null;
	$scope.errorEditName=false;
	$scope.errorAddComment=false;
	$scope.errorUpdateComments=false;
	$scope.errorDeleteComment=false;
	$scope.errorEditComment=false;
	$scope.errorDeletePoint=false;
	$scope.errorUpdatePoints=false;
	$rootScope.deleteGameOk=false;
	$scope.deleteGameKo=false;
	$scope.addPointKo=false;
	$scope.comentarioEdit=false;
	$scope.idComentario="";
	$scope.comentarioOld="";
	$scope.comentarioToEdit=null;
	$scope.tipoModal=null;
	$scope.patternName = /^[a-zA-ZäÄëËïÏöÖüÜáéíóúáéíóúÁÉÍÓÚÂÊÎÔÛâêîôûàèìòùÀÈÌÒÙñÑ ]*$/;
	$scope.paises=$rootScope.paises.europe;
	$scope.tipoSelected="costero";
	$scope.continenteSelected="europe";
	$scope.paisSelected="default";
	$scope.puntoPrint={};
	obtenerJuego();
	
	/**
	 * Abrir el perfil del usuario
	 */
	$scope.openUser = function (usuario) {
		
		if(usuario){//tengo usuario seleccionado
			$location.path("/home/users/"+usuario);
		}
	};
	
	function obtenerJuego(){
		idJuego = $location.path().substr($location.path().lastIndexOf("/") + 1);
		if(idJuego!== undefined && idJuego!== null){//tiene datos
			JuegoService.getJuegoById(idJuego)
			.then(function success(response){
				$scope.juego=response;
				$scope.juego.partidas.sort(function(a, b){return b.puntuacion - a.puntuacion}).splice(5);
				comprobarCreador();
			}, function error(error){
				console.log("No se ha podido obtener el juego");
				$scope.juego=null;
				$scope.creador=false;
				$location.path("/home");
			});
		}
		
	};
	
	function comprobarCreador(){
		if($rootScope.user.login===$scope.juego.creador.login){
			$scope.creador=true;
		}else{
			$scope.creador=false;
		}
	};
	
	$scope.editarNombre = function(){
		if($scope.nameOld!==$scope.juego.nombre){//si ha cambiado el nombre, se actualiza
			JuegoService.updateNombreJuego($rootScope.user.login, idJuego, $scope.juego.nombre)
			.then(function success(newJuego){
				console.log("Se ha actualizado el nombre del juego");
				updateJuego(newJuego);
				$scope.modoVistaNombre();
				$scope.errorEditName=false;
			}, function error(error){
				console.log("Error al actualizar el nombre del juego");
				$scope.juego.nombre=$scope.nameOld;
				$scope.modoVistaNombre();
				$scope.errorEditName=true;
				scrollToTop();
			});
		}else{//se va al modo vista
			console.log("No se ha cambiado el nombre");
			$scope.modoVistaNombre();
		}
	};
	
	/**
	 * Actualizar el juego de la lista de juegos del usuario
	 */
	function updateJuego(newJuego){
		var juegos=$rootScope.user.juegos;
		jQuery.each(juegos, function(index, item) {
			if (item.idJuego === newJuego.idJuego) {//actualizamos el juego en la lista
				$rootScope.user.juegos[index]=newJuego;
			}
		});
		
	}
	
	$scope.agregarComentario = function() {
		ComentarioService.postComentario($scope.newComentario, $rootScope.user.login, idJuego)
		.then(function success(response){
			console.log("Se ha añadido el comentario al juego");
			$scope.newComentario="";
			obtenerComentarios();
			$scope.errorAddComment=false;
		}, function error(error){
			console.log("Error al agregar el nuevo comentario");
			$scope.newComentario="";
			$scope.errorAddComment=true;
			scrollToTop();
			
		});
		
	};
	
	function obtenerComentarios(){
		ComentarioService.getComentariosByJuego(idJuego)
		.then(function success(response){
			console.log("se han obtenido los juegos");
			$scope.juego.comentarios=response;
			$scope.errorUpdateComments=false;
		}, function error(error){
			console.log("no se han podido obtener los juegos");
			$scope.errorUpdateComments=true;
			scrollToTop();
		});
	};
	
	/**
	 * Para coger el comentario seleccionado
	 */
	$("#confirmationDeleteComentarioModal").on("show.bs.modal", function(e){
		$scope.idComentario=$(e.relatedTarget).data().id;
	});

	/**
	 * Abrir el modal para agregar el punto
	 */
	$scope.openModalPoint = function(){
			$scope.view=1;//primera vista para buscar punto
			$('#confirmationAddPointModal').modal('show');
			$scope.$broadcast('initMapa');//inicializa el mapa para cuando se va a agregar un punto nuevo
	};
	
	/**
	 * Eliminar datos al al salir del modal
	 */
	$("#confirmationDeleteComentarioModal").on("hidden.bs.modal", function(e){
		$scope.idComentario="";
	});
	
	/**
	 * Eliminar datos al salir del modal
	 */
	$("#confirmationDeletePointModal").on("hidden.bs.modal", function(e){
		$scope.puntoDelete=null;
	});
	
	$scope.eliminarComentario = function(){
		ComentarioService.deleteComentario(idJuego, $scope.idComentario)
		.then(function success(response){
			console.log("Se ha eliminado el juego");
			obtenerComentarios();
			$scope.errorDeleteComment=false;
		}, function error(error){
			console.log("No se ha podido eliminar el juego");
			$scope.errorDeleteComment=true;
			scrollToTop();
		});
		
	};
	
	$scope.editarComentario = function() {
		if($scope.comentarioToEdit.descripcion!==$scope.comentarioOld){//llamar al servicio si ha cambiado el comentario
			ComentarioService.updateComentario(idJuego, $scope.comentarioToEdit)
			.then(function success(response){
				console.log("Se ha editado el comentario");
				$scope.comentarioToEdit.fechaModificacion=Date.now();
				$scope.modoVistaComentario();
				$scope.errorEditComment=false;
				
			},function error(error){
				console.log("No se ha podido editar el comentario");
				$scope.recogerValorAntiguo($scope.comentarioToEdit);
				$scope.modoVistaComentario();
				$scope.errorEditComment=true;
				scrollToTop();
				
			});
		}else{
			$scope.modoVistaComentario();
		}
	};
	
	/**
	 * Abre un modal dependiendo de si es el ultimo punto o no
	 */
	$scope.abrirPuntoModal=function(punto){
		if(isLastPunto()){//se abre modal para eliminar juego
			$('#confirmationLastPointModal').modal('show');
		}else{
			$scope.puntoDelete=punto;
			$("#confirmationDeletePointModal").modal('show');
		}
	};
	
	/**
	 * Comprueba si es el ultimo punto del juego
	 */
	function isLastPunto(){
		return $scope.juego.puntos.length===1;
	}
	
	
	/**
	 * Abrir el modal de confirmacion
	 */
	$scope.openModalConfirm = function(tipoModal, comentario){
		$scope.tipoModal=tipoModal;
		if(tipoModal===2){//estoy editando, guardo el comentario
			$scope.comentarioToEdit=comentario;
		}
		$('#confirmationAddComentarioModal').modal('show');
	};
	
	$scope.modoEdicionNombre = function(){
		$scope.nameOld=$scope.juego.nombre;
		$scope.edicionNombre=true;
	};
	
	$scope.modoEdicionComentario = function(comentario){
		$scope.comentarioOld=comentario.descripcion;//guardo el valor antiguo
		$scope.comentarioEdit=comentario.idComentario;
		$scope.edicionComentario=true;
	};
	
	$scope.recogerValorAntiguoNombreJuego = function(){
		$scope.juego.nombre=$scope.nameOld;
	};
	
	$scope.modoVistaNombre = function(){
		$scope.nameOld=null;
		$scope.edicionNombre=false;
	};
	
	$scope.recogerValorAntiguo = function(comentario){
		var id=comentario.idComentario;
		jQuery.each($scope.juego.comentarios, function() {
			if (this.idComentario === id) {//repongo el valor antiguo
				this.descripcion=$scope.comentarioOld;
				$scope.comentarioOld="";
			}
		});
	};
	
	$scope.modoVistaComentario = function(){
		$scope.comentarioEdit=null;
		$scope.edicionComentario=false;
	};
	
	$scope.eliminarPunto = function(){
		if($scope.puntoDelete!==null){//existe punto a borrar, se llama al servicio
			PuntoGeograficoService.deletePuntoGeografico(idJuego, $scope.puntoDelete.idPunto)
			.then(function success(response){
				console.log("Se ha eliminado el punto");
				obtenerPuntosGeograficos();
				$scope.errorDeletePoint=false;
			}, function error(error){
				$scope.errorDeletePoint=true;
				scrollToTop();
				console.log("No se ha podido eliminar el punto");
			});
		}
		
	};
	
	$scope.eliminarJuego = function(){
		JuegoService.deleteJuego($rootScope.user.login, idJuego)
		.then(function success(){
			console.log("Se ha eliminado el juego");
			obtenerJuegosUsuario();
			$rootScope.deleteGameOk=true;
			$scope.deleteGameKo=false;
			$location.path("/home");
		}, function error(error){
			console.log("Error al eliminar el juego");
			$rootScope.deleteGameOk=false;
			$scope.deleteGameKo=true;
		});
	};
	
	function obtenerJuegosUsuario(){
		JuegoService.getJuegosByLogin($rootScope.user.login)
		.then(function successs(response){
			$rootScope.user.juegos=response;
		}, function error(error){
			console.log("error obteniendo los juegos del usuario");
		});
	};
	
	function obtenerPuntosGeograficos(){
		PuntoGeograficoService.getPuntosGeograficosByJuego(idJuego)
		.then(function success(response){
			$scope.juego.puntos=response;
			$scope.errorUpdatePoints=false;
		}, function error(error){
			$scope.errorUpdatePoints=true;
			scrollToTop();
		});
	};
	
	/**
	 * Recibe el agregado de un punto del mapa
	 */
	$scope.openModalAddPoint = function(place){
		$scope.pointExist=false;
		if(!compruebaSiExiste(place)){
			$scope.place=place;
			$scope.paises=$rootScope.paises.europe;
			$scope.view=2;//primera vista del formulario para añadir punto
			$scope.pointExist=false;
		}else{//mostrar error de existencia del punto en el juego
			$scope.pointExist=true;
			scrollToTopModal("#confirmationAddPointModal");
		}
	};
	
	/**
	 * Obtiene el nombre del punto buscado hasta la primera coma si la hay
	 */
	function obtenerNombreLugar(place){
		var nombre;
		if(place.display_name.indexOf(",")>-1){
			nombre=place.display_name.substring(0, place.display_name.indexOf(","));
		}else{
			nombre=place.display_name;
		}
		return nombre;
	};
	
	$scope.changeView=function(view){
		if(view===3){
			var nombre=obtenerNombreLugar($scope.place);
			$scope.puntoPrint = {
				"nombre":nombre,
				"tipo":$rootScope.tipoPunto[$scope.tipoSelected],
				"pais":$rootScope.paises[$scope.continenteSelected][$scope.paisSelected],
				"continente":$rootScope.continentes[$scope.continenteSelected]
			};
		}
		
		$scope.view=view;
	};
	
	$scope.agregarPunto=function(){
		var nombre=obtenerNombreLugar($scope.place);
		var punto={
				"nombre":nombre,
				"latitud":$scope.place.lat,
				"longitud":$scope.place.lon,
				"pais":$scope.paisSelected,
				"continente":$scope.continenteSelected,
				"tipoPunto":$scope.tipoSelected
				
		};
		PuntoGeograficoService.postPuntoGeografico(idJuego, punto)
		.then(function success(response){
			$scope.addPointKo=false;
			obtenerPuntosGeograficos();
			scrollToElement(".infoPuntos");
		}, function error(error){
			$scope.addPointKo=true;
			scrollToTop();
		});
		
	};
	
	$scope.changeContinent=function(){
		 if($scope.continenteSelected==="europe"){
			 $scope.paises=$rootScope.paises.europe;
			 $scope.paisSelected="default";
		 }else if($scope.continenteSelected==="america"){
			 $scope.paises=$rootScope.paises.america;
			 $scope.paisSelected="default";
		 }else if($scope.continenteSelected==="asia"){
			 $scope.paises=$rootScope.paises.asia;
			 $scope.paisSelected="default";
		 }else if($scope.continenteSelected==="africa"){
			 $scope.paises=$rootScope.paises.africa;
			 $scope.paisSelected="default";
		 }else if($scope.continenteSelected==="oceania"){
			 $scope.paises=$rootScope.paises.oceania;
			 $scope.paisSelected="default";
		 }
	 };
	
	/**
	 * Eliminar datos al al salir del modal
	 */
	$("#confirmationAddPointModal").on("hidden.bs.modal", function(e){
		$scope.continenteSelected="europe";
		$scope.paises=$rootScope.paises.europe;
		$scope.paisSelected="default";
		$scope.tipoSelected="costero";
		$scope.pointExist=false;
	});
	
	function compruebaSiExiste(puntoSelect){
		var existe=false;
		jQuery.each($scope.juego.puntos, function(index, punto) {
			if (punto.latitud.toString() === puntoSelect.lat && punto.longitud.toString() === puntoSelect.lon) {
				existe=true;
			}
		});
		return existe;
	}
	
	$scope.jugar = function(){
		if(idJuego){//tengo usuario seleccionado
			$location.path("/home/juegos/"+idJuego+"/play");
		}
	}
});