app.controller('ListaJuegosController', function($rootScope, $scope, $http, $location, UserService, JuegoService) {
	scrollToTopNoAnimated();
	$rootScope.portada=false;
	$scope.idJuego=undefined;
	$scope.deleteGameOk=false;
	$scope.deleteGameKo=false;
	
	/**
	 * Abrir el perfil del juego seleccionado
	 */
	$scope.openGame = function (idJuego) {
		
		if(idJuego){//tengo juego seleccionado
			$location.path("/home/juegos/"+idJuego);
		}
	};
	
	/**
	 * Para mostrar los datos del juego en el modal
	 */
	$("#confirmationDeleteGameModal").on("show.bs.modal", function(e){
		var nombre=$(e.relatedTarget).data().nombre;
		$scope.idJuego=$(e.relatedTarget).data().id;
		$(e.currentTarget).find(".gameName").text(nombre);
	});
	
	/**
	 * Eliminar el usuario seleccionado al salir del modal
	 */
	$("#confirmationDeleteGameModal").on("hidden.bs.modal", function(e){
		$scope.idJuego="";
	});
	
	/**
	 * Eliminar juego del usuario
	 */
	$scope.eliminarJuego=function(){
		JuegoService.deleteJuego($rootScope.user.login, $scope.idJuego)
		.then(function success(){
			obtenerJuegosUsuario();
			$scope.deleteGameOk=true;
			$scope.deleteGameKo=false;
		}, function error(error){
			$scope.deleteGameOk=false;
			$scope.deleteGameKo=true;
		});
	};
	
	function obtenerJuegosUsuario(){
		JuegoService.getJuegosByLogin($rootScope.user.login)
		.then(function successs(response){
			$rootScope.user.juegos=response;
		}, function error(error){
		});
	};
	
	
	/**
	 * Para mostrar los datos del juego en el modal
	 */
	$("#compartirJuegoModal").on("show.bs.modal", function(e){
		$scope.juegoShare=$(e.relatedTarget).data().juego;
		$scope.visibilidadActual=$scope.juegoShare.visibilidad.idTipoVisibilidad;//guardar la visibilidad actual del logro
		$scope.visibilidad=$scope.juegoShare.visibilidad.idTipoVisibilidad;
		$(e.currentTarget).find(".juegoName").text($scope.juegoShare.nombre);
		$(e.currentTarget).find("#radio"+$scope.visibilidad).prop("checked",true);	
	});
	
	/**
	 * Eliminar los datos especificos del logro seleccionado
	 */
	$("#compartirJuegoModal").on("hidden.bs.modal", function(e){
		$(e.currentTarget).find("#radio"+$scope.visibilidad).prop("checked",false);
		$scope.visibilidadActual=null;
		$scope.visibilidad=null;
	});
	
	/**
	 * Realiza la llamada al servicio para cambiar la visibilidad de un juego
	 */
	$scope.compartirJuego = function(){
		var juego=$scope.juegoShare;
		var visibilidad=$scope.visibilidad;
		if(visibilidad!==$scope.visibilidadActual){//si se ha cambiado la visibilidad se actualiza
			JuegoService.putJuegoVisibilidad($rootScope.user.login, $scope.juegoShare.idJuego, visibilidad)
				.then(function success(newJuego){
					updateJuego(newJuego);
					$scope.shareOk=true;
					$scope.shareKo=false;
					scrollToTop();
				}, function error(error){
					$scope.shareOk=false;
					$scope.shareKo=true;
					scrollToTop();
				});
		}else{
		}
	};
	
	/**
	 * Actualizar el juego de la lista de juegos del usuario
	 */
	function updateJuego(newJuego){
		var juegos=$rootScope.user.juegos;
		jQuery.each(juegos, function(index, item) {
			if (item.idJuego === newJuego.idJuego) {//actualizamos el juego en la lista
				$rootScope.user.juegos[index]=newJuego;
			}
		});
		
	}
});