app.controller('PartidaController', function($rootScope, $scope, $location, JuegoService, PartidaService, LogroService) {
	scrollToTopNoAnimated();
	$rootScope.portada=false;
	var SUMA_PUNTOS=5;
	var RESTA_PUNTOS=2;
	var CERO=0;
	var puntosARestar=0;
	$scope.nivelJuego=undefined;
	$scope.modoJuego=undefined;
	$scope.juego=undefined;
	$scope.respuestaNombrar=undefined;
	$scope.comenzar=false;
	$rootScope.savePartidaKo=false;
	$scope.jugarLocalizar=false;
	$scope.jugarNombrar=false;
	$scope.correcto=undefined;
	$scope.puntos=[];
	$scope.fallos=[];
	$scope.aciertos=[];
	$scope.puntuacion=0;
	$scope.numAciertos=0;
	$scope.numFallos=0;
	$scope.acierto=false;
	$scope.fallo=false;
	var idJuego;
	var nivelDefecto="facil";
	var modoDefecto="localizar"
	$('[data-toggle="tooltip"]').tooltip();  
	
	obtenerJuego();
	openModalSeleccionDatos();
	
	function obtenerJuego(){
		var url = $location.path().substr(0, $location.path().lastIndexOf("/"));
		idJuego=url.substr(url.lastIndexOf("/")+1);
		if(idJuego!== undefined && idJuego!== null){//tiene datos
			JuegoService.getJuegoById(idJuego)
			.then(function success(response){
				$scope.juego=response;
			}, function error(error){
				$scope.juego=null;
				$('#seleccionDatosModal').modal('hide');
				$location.path("/home");
			});
		}
		
	};
	
	function openModalSeleccionDatos(){
		if(window.localStorage){
			if(localStorage.getItem("nivelJuego")){
				$scope.nivelJuego=localStorage.getItem("nivelJuego");
			}else{
				$scope.nivelJuego=nivelDefecto;
			}
			if(localStorage.getItem("modoJuego")){
				$scope.modoJuego=localStorage.getItem("modoJuego");
			}else{
				$scope.modoJuego=modoDefecto;
			}
		}else{
			$scope.nivelJuego=nivelDefecto;
			$scope.modoJuego=modoDefecto;
		}
		
		$scope.view=1;
		$('#seleccionDatosModal').modal('show');
	}
	
	$scope.changeView = function(view){
		$scope.view=view;
	};
	
	$scope.salir = function(){
		$('#seleccionDatosModal').modal('hide');
		$location.path($location.path().substr(0,$location.path().lastIndexOf("/"))); //redirige a la pagina del juego
	};
	
	$scope.jugar = function(){
		if(($scope.nivelJuego==="facil" || $scope.nivelJuego==="medio" || $scope.nivelJuego==="avanzado") && ($scope.modoJuego==="localizar") || ($scope.modoJuego==="nombrar")){//si continen datos para jugar
			$('#seleccionDatosModal').modal('hide');
			localStorage.setItem("nivelJuego", $scope.nivelJuego);
			localStorage.setItem("modoJuego", $scope.modoJuego);
			
			if($scope.modoJuego==="localizar"){
				jugarALocalizarPunto();
			}else {
				jugarANombrarPunto();
			}
		}else{//ir a la pagina del juego
			$('#seleccionDatosModal').modal('hide');
			$location.path($location.path().substr(0,$location.path().lastIndexOf("/")));
		}
	};
	
	function jugarALocalizarPunto(){
		$scope.puntos = JSON.parse(JSON.stringify($scope.juego.puntos));
		$scope.$broadcast('createMarkersLocalizar', $scope.puntos);
		$scope.seleccionarPunto();
		$scope.comenzar=true;
	};
	
	function jugarANombrarPunto(){
		$scope.puntos = JSON.parse(JSON.stringify($scope.juego.puntos));
		$scope.seleccionarPunto();
		$scope.comenzar=true;
	};
	
	/**
	 * Comprueba si un punto es correcto para el modo de juego de localizar punto
	 */
	$scope.comprobarPuntoLocalizar = function(place){
		if(place.latitud===$scope.punto.latitud && place.longitud===$scope.punto.longitud){
			$scope.correcto=true;
		}else{
			$scope.correcto=false;
		}
		$scope.calculoRespuesta();
	};
	
	/**
	 * Comprueba si el punto es correcto para la funcionalidad de nombrar punto
	 */
	$scope.comprobarPuntoNombrar = function(){
		if(eliminarAcentos($scope.punto.nombre.toLowerCase()).indexOf(eliminarAcentos($scope.respuestaNombrar.toLowerCase()))>-1){//contiene la cadena
			$scope.correcto=true;
		}else{
			$scope.correcto=false;
		}
		$scope.calculoRespuesta();
		$scope.respuestaNombrar="";
		
	};
	
	$scope.seleccionarPunto = function(){
		if($scope.puntos.length!==0){
			var random = Math.floor(Math.random()*$scope.puntos.length);
			$scope.punto= $scope.puntos[random];
			if($scope.modoJuego==="nombrar"){
				$scope.$broadcast('createMarkersNombrar', $scope.nivelJuego, $scope.punto);
			}
		}else{
			console.log("Se ha terminado la partida");
			if($scope.puntuacion-puntosARestar<0){
				$scope.puntuacion=CERO;
			}else{
				$scope.puntuacion=$scope.puntuacion-puntosARestar;
			}
			openModalResultados();
		}
	};

	/**
	 * Calcula la nueva puntuacion con el nuevo punto agregando el fallo u acierto
	 */
	$scope.calculoRespuesta = function(){
		if($scope.correcto){//es el punto correcto
			$scope.puntuacion=$scope.puntuacion+SUMA_PUNTOS;
			$scope.aciertos.push($scope.punto);
		}else{
			puntosARestar=puntosARestar+RESTA_PUNTOS;
			$scope.fallos.push($scope.punto);
		}
		mostrarResultado($scope.correcto, $scope.punto);
		eliminarPunto($scope.puntos);
	}
	
	
	$scope.volverAlJuego = function(){
		$('#resultadosModal').modal('hide');
		$location.path($location.path().substr(0,$location.path().lastIndexOf("/")));
	};
	
	$scope.savePartida = function(){
		$('#resultadosModal').modal('hide');
		console.log("Se va a guardar la partida");
		var partida={
				"puntuacion":$scope.puntuacion,
				"modoJuego":$scope.modoJuego,
				"nivelJuego":$scope.nivelJuego,
				"aciertos":$scope.aciertos,
				"fallos":$scope.fallos
				
		};
		PartidaService.postPartida(idJuego, partida)
		.then(function success(response){
			console.log("Se ha guardado la partida");
			$rootScope.savePartidaKo=false;
			comprobarLogros();
		}, function error(error){
			$scope.volverAlJuego();
			$rootScope.savePartidaKo=true;
		});
	};
	
	function comprobarLogros() {
		LogroService.getLogrosNuevos($rootScope.user.login)
			.then(function success(response){
				console.log("Se han obtenido los logros");
				$scope.logrosConseguidos=response;
				redireccionLogrosConseguidos();
				
			}, function error(error){
				$scope.volverAlJuego();
			});
	};
	
	/**
	 * Cerrar el modal de logro conseguido
	 */
	$scope.closeModalLogroConseguido = function(){
		$('#logrosModal').modal('hide');
		$scope.volverAlJuego();
	};
	
	
	/**
	 * Va al juego si no quedan logros, y si no muestra el nuevo modal con el siguiente logro
	 */
	function redireccionLogrosConseguidos(){
		if($scope.logrosConseguidos.length!=CERO){
			openModalLogrosConseguidos();
		}else{
			$scope.volverAlJuego();
		}
		
	};
	
	/**
	 * Abrir el modal con los logros conseguidos
	 */
	function openModalLogrosConseguidos(){
		$('#logrosModal').modal('show');
	};

	
	function mostrarResultado(correcto, punto){
		if($scope.nivelJuego==="facil"){
			if(correcto){
				$scope.numAciertos=$scope.numAciertos+1;
			}else{
				$scope.numFallos=$scope.numFallos+1;
			}
		}else if($scope.nivelJuego==="medio"){
			if(correcto){
				$scope.acierto=true;
				$scope.fallo=false;
			}else{
				$scope.fallo=true;
				$scope.acierto=false;
			}
		}
		$scope.$broadcast('changeMarker', $scope.modoJuego, $scope.nivelJuego, correcto);
		
	};
	
	function eliminarPunto(puntos){
		jQuery.each(puntos, function(index, item) {
			if (item.latitud === $scope.punto.latitud && item.longitud === $scope.punto.longitud) {//actualizamos el juego en la lista
				$scope.puntos.splice(index, 1);
				return false;
			}
		});
		$scope.seleccionarPunto();
	}
	
	function openModalResultados(){
		$('#resultadosModal').modal('show');
	};
	
	/**
	 * Funcion para eliminar los acentos de una cadena de texto
	 */
	function eliminarAcentos(texto){
		var cadena=texto;
		cadena = cadena.replace(/á/gi,"a");
		cadena = cadena.replace(/é/gi,"e");
		cadena = cadena.replace(/í/gi,"i");
		cadena = cadena.replace(/ó/gi,"o");
		cadena = cadena.replace(/ú/gi,"u");
		return cadena;
	};
});