app.service("JuegoService", function($http, $q) {
	
	var juego=undefined;
	var juegos=undefined;
	var searchJuegos=undefined;
	var juegoEliminado=undefined;
	var juegoCreado= undefined;
	var juegosUser=undefined;
	var updateNameJuego=undefined;
	var updateVisibilidadJuego=undefined;
	
	this.deleteJuego = function(usuario, idJuego) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.delete("/usuarios/"+usuario+"/juegos/"+idJuego)
		.then(function(response) {
			juegoEliminado= response.data;
			defered.resolve(juegoEliminado);
		},
			function error(error) {
				defered.reject(error);
			});

		return promise;
	};
	
	this.postJuego = function(usuario, game) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.post("/usuarios/"+usuario+"/juegos", {
			nombre:game.nombre,
			puntos:game.puntos
		})
		.then(function(response) {
			juegoCreado= response.data;
			defered.resolve(juegoCreado);
		},
			function error(error) {
				defered.reject(error);
			});

		return promise;
	};
	
	this.getJuegosByLogin = function(usuario) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.get("/usuarios/"+usuario+"/juegos")
		.then(function(response) {
			juegosUser= response.data;
			defered.resolve(juegosUser);
		},
			function error(error) {
				defered.reject(error);
			});

		return promise;
	};
	
	this.getJuegosByText = function(text) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.get("/juegos?text="+text)
		.then(function(response) {
			searchJuegos= response.data;
			defered.resolve(searchJuegos);
		},
			function error(error) {
				defered.reject(error);
			});

		return promise;
	};
	
	this.getJuegoById=function(idJuego){
		var defered = $q.defer();
		var promise = defered.promise;
		$http.get("/juegos/"+idJuego)
		.then(function(response) {
			juego= response.data;
			defered.resolve(juego);
		},
			function error(error) {
				defered.reject(error);
			});

		return promise;
	};
	
	this.updateNombreJuego = function(usuario, idJuego, nuevoNombre) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.put("/usuarios/"+usuario+"/juegos/"+idJuego+"?nombre="+nuevoNombre)
		.then(function(response) {
			updateNameJuego= response.data;
			defered.resolve(updateNameJuego);
		},
			function error(error) {
				defered.reject(error);
			});

		return promise;
	};
	
	this.putJuegoVisibilidad = function(usuario, idJuego, visibilidad) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.put("/usuarios/"+usuario+"/juegos/"+idJuego+"?visibilidad="+visibilidad)
		.then(function(response) {
			updateVisibilidadJuego= response.data;
			defered.resolve(updateVisibilidadJuego);
		},
			function error(error) {
				defered.reject(error);
			});

		return promise;
	};
	
	this.updateJuegoVisibilidad=function(){
		return updateVisibilidadJuego;
	};
	
	this.getSearchJuegos=function(){
		return searchJuegos;
	};
	
	this.getJuego=function(){
		return juego;
	};
});