app.service("PuntoGeograficoService", function($http, $q) {
	
	var deletePunto = undefined;
	var puntos = undefined;
	
	
	this.postPuntoGeografico = function(idJuego, punto) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.post("/juegos/"+idJuego+"/puntos",{
			continente:punto.continente,
			nombre:punto.nombre,
			pais:punto.pais,
			latitud:punto.latitud,
			longitud:punto.longitud,
			idTipoPunto:{
				tipoPunto:punto.tipoPunto
			}
		})
		.then(function(response) {
			deletePunto = response.data;
			defered.resolve(deletePunto);
		}, function error(error) {
			defered.reject(error);
		});
		return promise;
	}
	
	/**
	 * Envía la petición para eliminar un punto geografico
	 */
	this.deletePuntoGeografico = function(idJuego, idPunto) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.delete("/juegos/"+idJuego+"/puntos/"+idPunto)
		.then(function(response) {
			deletePunto = response.data;
			defered.resolve(deletePunto);
		}, function error(error) {
			defered.reject(error);
		});
		return promise;
		
	};
	
	this.getPuntosGeograficosByJuego = function(idJuego){
		var defered = $q.defer();
		var promise = defered.promise;
		$http.get("/juegos/"+idJuego+"/puntos").then(function(response) {
			puntos = response.data;
			defered.resolve(puntos);
		}, function error(error) {
			defered.reject(error);
		});
		return promise;

	};
	
	
});