app.service("SolicitudAmistadService", function($http, $q) {

	var solicitud = undefined;
	var solicitudesEnviadas=undefined;
	var solicitudesRecibidas=undefined;
	var updateSolicitud=undefined;
	
	this.postSolicitud = function(emisor, receptor) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.post("/solicitudes", {
			emisor : emisor,
			receptor : receptor
		}).then(function(response) {
			solicitud = response.data;
			defered.resolve(solicitud);
		},
			function error(error) {
				defered.reject(error);
			});

		return promise;
	};
	
	this.obtenerSolicitudesEnviadas = function(login, estado) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.get("/solicitudes/"+login+"/solicitudesEnviadas?estado="+estado).then(function(response) {
			solicitudesEnviadas = response.data;
			defered.resolve(solicitudesEnviadas);
		},
			function error(error) {
				defered.reject(error);
			});

		return promise;
	};
	
	this.obtenerSolicitudesRecibidas = function(login, estado) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.get("/solicitudes/"+login+"/solicitudesRecibidas?estado="+estado).then(function(response) {
			solicitudesRecibidas = response.data;
			defered.resolve(solicitudesRecibidas);
		},
			function error(error) {
				defered.reject(error);
			});

		return promise;
	};
	
	this.actualizarSolicitud = function(idSolicitud, estado){
		var defered = $q.defer();
		var promise = defered.promise;
		$http.put("/solicitudes/"+idSolicitud+"?estado="+estado).then(function(response) {
			updateSolicitud = response.data;
			defered.resolve(updateSolicitud);
		},
			function error(error) {
				defered.reject(error);
			});

		return promise;
	};
	
	this.getSolicitudesEnviadas = function() {
		return solicitudesEnviadas;
	}
	
	this.getSolicitudesRecibidas = function() {
		return solicitudesRecibidas;
	}
});