/**
 * 
 */
app.controller('CrearJuegoController', function($scope, $rootScope, $translate, JuegoService) {
	scrollToTopNoAnimated();
	$rootScope.portada=false;
	$scope.patternName = /^[a-zA-ZäÄëËïÏöÖüÜáéíóúáéíóúÁÉÍÓÚÂÊÎÔÛâêîôûàèìòùÀÈÌÒÙñÑ ]*$/;
	$scope.game={
			"nombre":"",
			"puntos":""
	};
	$scope.puntos=[];
	$scope.si=false;
	$scope.pointExist=false;
	$scope.newGameKo=false;
	$scope.newGameOk=false;
	$scope.openFormAddPoint=false;
	$scope.paises=$rootScope.paises.europe;
	$scope.tipoSelected="costero";
	$scope.continenteSelected="europe";
	$scope.paisSelected="default";
	$scope.message = "Inicio.";
	$scope.puntoPrint={};
	$scope.date=new Date();
	$('[data-toggle="tooltip"]').tooltip();
	$rootScope.crearJuegoMapa=true;
	  
	/**
	 * Actualizar los dropdown de paises acorde al continente seleccionado
	 */
	 $scope.changeContinent=function(){
		 if($scope.continenteSelected==="europe"){
			 $scope.paises=$rootScope.paises.europe;
			 $scope.paisSelected="default";
		 }else if($scope.continenteSelected==="america"){
			 $scope.paises=$rootScope.paises.america;
			 $scope.paisSelected="default";
		 }else if($scope.continenteSelected==="asia"){
			 $scope.paises=$rootScope.paises.asia;
			 $scope.paisSelected="default";
		 }else if($scope.continenteSelected==="africa"){
			 $scope.paises=$rootScope.paises.africa;
			 $scope.paisSelected="default";
		 }else if($scope.continenteSelected==="oceania"){
			 $scope.paises=$rootScope.paises.oceania;
			 $scope.paisSelected="default";
		 }
	 };
		
		$scope.agregarPunto=function(){
			console.log("Se agrega el punto a la lista");
			var nombre=obtenerNombreLugar($scope.place);
			var punto={
					"nombre":nombre,
					"latitud":$scope.place.lat,
					"longitud":$scope.place.lon,
					"pais":$scope.paisSelected,
					"continente":$scope.continenteSelected,
					"tipoPunto":$scope.tipoSelected
					
			};
			$scope.puntos.push(punto);
			scrollToElement("#infoPuntos");
		};
		
		/**
		 * Obtiene el nombre del punto buscado hasta la primera coma si la hay
		 */
		function obtenerNombreLugar(place){
			var nombre;
			if(place.display_name.indexOf(",")>-1){
				nombre=place.display_name.substring(0, place.display_name.indexOf(","));
			}else{
				nombre=place.display_name;
			}
			return nombre;
		};
		
		$scope.changeView=function(view){
			console.log("Se va a cambiar la vista");
			var nombre=obtenerNombreLugar($scope.place);
			$scope.puntoPrint = {
				"nombre":nombre,
				"tipo":$rootScope.tipoPunto[$scope.tipoSelected],
				"pais":$rootScope.paises[$scope.continenteSelected][$scope.paisSelected],
				"continente":$rootScope.continentes[$scope.continenteSelected]
			};
			console.log(JSON.stringify($scope.puntoPrint));
			$scope.view=view;
		};
		
		/**
		 * Eliminar punto de la lista de puntos agregados
		 */
		$scope.eliminarPunto=function(puntoSelect){
			jQuery.each($scope.puntos, function(index, punto) {
				if (punto.nombre === puntoSelect.nombre && punto.tipoPunto === puntoSelect.tipoPunto && punto.pais === puntoSelect.pais && punto.continente === puntoSelect.continente && punto.latitud === puntoSelect.latitud && punto.longitud === puntoSelect.longitud) {
					$scope.puntos.splice(index,1);
					console.log("Se ha eliminado el punto de la lista");
				}
			});
		};
		
		$scope.openModalDeletePoint=function(puntoSeleccionado){
			$scope.puntoToDelete=puntoSeleccionado;
			$('#confirmationDeletePointModal').modal('show');
		};
		
		/**
		 * Salir del modal de confirmacion para eliminar un punto
		 */
		$("#confirmationDeletePointModal").on("hidden.bs.modal", function(e){
			$scope.puntoToDelete=undefined;
		});
		
		/**
		 * Abrir el modal para agregar un punto
		 */
		$scope.openModalAddPoint = function(punto){
			if(!compruebaSiExiste(punto)){
				$scope.place=punto;
				$scope.paises=$rootScope.paises.europe;
				$scope.view=1;//primera vista del formulario para añadir punto
				console.log("Se va a abrir el modal para agregar punto");
				$('#confirmationAddPointModal').modal({backdrop: 'static', keyboard: false});
				$('#confirmationAddPointModal').modal('show');
				$scope.pointExist=false;
			}else{
				$scope.pointExist=true;
				scrollToTop();
			}
			
		};
		/**
		 * Abrir modal para crear el juego
		 */
		$scope.openModalCreateGame = function(){
			$scope.game.puntos=$scope.puntos;
			console.log("Juego: "+JSON.stringify($scope.game));
			$('#confirmationCreateGameModal').modal({backdrop: 'static', keyboard: false});
			$('#confirmationCreateGameModal').modal('show');
		};
		
		/**
		 * Eliminar datos al al salir del modal
		 */
		$("#confirmationAddPointModal").on("hidden.bs.modal", function(e){
			$scope.continenteSelected="europe";
			$scope.paises=$rootScope.paises.europe;
			$scope.paisSelected="default";
			$scope.tipoSelected="costero";
		});
		
		$scope.goToAddPoint = function (){
			scrollToElement('#formAddPoint');
		};
		
		/**
		 * Realiza la llamada al servicio para añadir el nuevo juego
		 */
		$scope.createGame = function(){
			console.log("Se va a crear el juego");
			JuegoService.postJuego($rootScope.user.login, $scope.game)
			.then(function success(){
				$scope.newGameKo=false;
				$scope.newGameOk=true;
				scrollToTop();
				resetVariables();
				obtenerJuegos();
				console.log("se ha creado el juego correctamente");
			},
			function error(error){
				$scope.newGameKo=true;
				$scope.newGameOk=false;
				scrollToTop();
				console.log("No se ha podido crear el juego");
			});
		};
		
		/**
		 * Actualizar los juegos del usuario
		 */
		function obtenerJuegos(){
			JuegoService.getJuegosByLogin($rootScope.user.login)
			.then(function success(data){
				$rootScope.user.juegos=data;
				console.log("Se han actualizado los juegos");
			}, function error(error){
				console.log("No se han podido actualizar los juegos");
			});
		}
		
		function resetVariables(){
			$scope.game.nombre="";
			$scope.game.puntos=[];
			$scope.puntos=[];
			$scope.puntoPrint={};
			$scope.formCreateGame.$setPristine();
		}
		
		function compruebaSiExiste(puntoSelect){
			var existe=false;
			jQuery.each($scope.puntos, function(index, punto) {
				if (punto.latitud === puntoSelect.lat && punto.longitud === puntoSelect.lon) {
					existe=true;
					console.log("El punto ya existe en la lista");
				}
			});
			return existe;
		}
});