app.controller('ListaLogrosController', function($rootScope, $scope, LogroService) {
	scrollToTopNoAnimated();
	$rootScope.portada=false;
	$scope.visibilidadActual=null;
	$scope.visibilidad=null;
	$scope.idTipoLogro=null;
	$scope.shareOk=false;
	$scope.shareKo=false;
	
	/**
	 * Para mostrar los datos del logro en el modal
	 */
	$("#compartirLogroModal").on("show.bs.modal", function(e){
		var logro=$(e.relatedTarget).data().logro;
		var visibilidad=$(e.relatedTarget).data().visibilidad;
		$scope.visibilidadActual=visibilidad;//guardar la visibilidad actual del logro
		$scope.visibilidad=visibilidad;
		$(e.currentTarget).find("#radio"+visibilidad).prop("checked",true);
		$scope.idTipoLogro=$(e.relatedTarget).data().id;
		$(e.currentTarget).find(".logro").text(logro);
	});
	
	/**
	 * Eliminar los datos especificos del logro seleccionado
	 */
	$("#compartirLogroModal").on("hidden.bs.modal", function(e){
		$(e.currentTarget).find("#radio"+$scope.visibilidad).prop("checked",false);
		$scope.idTipoLogro=null;
		$scope.visibilidadActual=null;
		$scope.visibilidad=null;
	});
	
	/**
	 * Realiza la llamada al servicio para cambiar la visibilidad de un logro
	 */
	$scope.compartirLogro = function(){
		var idLogro=$scope.idTipoLogro;
		var visibilidad=$scope.visibilidad;
		if(visibilidad!==$scope.visibilidadActual){//si se ha cambiado la visibilidad se actualiza
			LogroService.putLogro($rootScope.user.login, idLogro, visibilidad)
				.then(function success(newLogro){
					updateLogro(newLogro);
					$scope.shareOk=true;
					$scope.shareKo=false;
					scrollToTop();
					console.log("Éxito al compartir el logro");
				}, function error(error){
					$scope.shareOk=false;
					$scope.shareKo=true;
					scrollToTop();
				});
		}
	};
	/**
	 * Actualizar el logro de la lista de logros del usuario
	 */
	function updateLogro(newLogro){
		var logros=$rootScope.user.logros;
		jQuery.each(logros, function(index, item) {
			if (item.id.tipoLogro.idTipoLogro === newLogro.id.tipoLogro.idTipoLogro) {
				$rootScope.user.logros[index]=newLogro;
			}
		});
		
	}
});