app.service("ComentarioService", function($http, $q) {

	var comentario = undefined;
	var createdComentario=undefined;
	var comentarios=undefined;
	var deleteComentario=undefined;
	var updateComentario=undefined;
	
	/**
	 * Envía la petición para crear un nuevo comentario
	 */
	this.postComentario = function(comentario, usuario, idJuego) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.post("/juegos/"+idJuego+"/comentarios", {
			descripcion : comentario,
			creador : usuario
		}).then(function(response) {
			createdComentario = response.data;
			defered.resolve(createdComentario);
		}, function error(error) {
			defered.reject(error);
		});
		return promise;
		
	};

	this.getComentariosByJuego = function(idJuego){
		var defered = $q.defer();
		var promise = defered.promise;
		$http.get("/juegos/"+idJuego+"/comentarios").then(function(response) {
			comentarios = response.data;
			defered.resolve(comentarios);
		}, function error(error) {
			defered.reject(error);
		});
		return promise;

	};
	
	/**
	 * Envía la petición para eliminar un comentario
	 */
	this.deleteComentario = function(idJuego, idComentario) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.delete("/juegos/"+idJuego+"/comentarios/"+idComentario)
		.then(function(response) {
			deleteComentario = response.data;
			defered.resolve(deleteComentario);
		}, function error(error) {
			defered.reject(error);
		});
		return promise;
		
	};
	
	/**
	 * Envía la petición para actualizar un comentario
	 */
	this.updateComentario = function(idJuego, comentarioEditado) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.put("/juegos/"+idJuego+"/comentarios/"+comentarioEditado.idComentario, {
			descripcion : comentarioEditado.descripcion
		})
		.then(function(response) {
			updateComentario = response.data;
			defered.resolve(updateComentario);
		}, function error(error) {
			defered.reject(error);
		});
		return promise;
		
	};
	
	this.getComentario = function() {
		return comentario;
	};
	
	this.getComentarios = function() {
		return comentarios;
	};

});